class ChatData {
  constructor () {
    this.mongoose = require('mongoose')
    this.mongoose.connect('mongodb://localhost/wbd3_chat')

    this.chatSchema = new this.mongoose.Schema({
      participant_ids: [Number],
      chats: [{
        owner_id: Number,
        content: String
      }]
    })
    this.ChatModel = this.mongoose.model('Chat', this.chatSchema)
  }

  addChat (senderId, receiverId, content) {
    var participantIds = [ senderId, receiverId ]
    participantIds.sort()

    var chat = {
      owner_id: senderId,
      content: content
    }

    this.ChatModel.findOneAndUpdate(
      { participant_ids: participantIds },
      { $push: { chats: chat } }, (err, done) => {
        if (err) {
          console.error(err)
        }
        if (!done) {
          var chat = new this.ChatModel({
            participant_ids: participantIds,
            chats: [{
              owner_id: senderId,
              content: content
            }]
          })

          chat.save()
        }
      })
  }
}
